import pygame
import sys
from random import randint

DEFAUTLT_FPS = 30

NUMBER_OF_ROWS = 5
NUMBER_OF_COLS = 11

INVADER_TYPE_TRIANGLE = 0
INVADER_TYPE_SQUARE = 1
INVADER_TYPE_ROUND = 2

WIDTH = 450
HEIGHT = 500

BLACK = (0, 0, 0)
WHITE = (255, 255, 255)
BLUE = (0, 0, 255)
GREEN = (0, 255, 0)
RED = (255, 0, 0)
YELLOW = (255, 216, 0)

START_SPEED = 9.0

invader_num = NUMBER_OF_COLS * NUMBER_OF_ROWS

cycle_reduction = START_SPEED / (invader_num)

XOFFSET = 80
YOFFSET = 80
score = 0
level = 0
lives = 3
max_lives = lives
dead_or_alive = []

barrier_outside_corner_L = 0
barrier_solid = 1
barrier_outside_corner_R = 2
barrier_inside_corner_L = 3
barrier_inside_corner_R = 4
empty = 5

barrier_pos = [[barrier_outside_corner_L, barrier_solid, barrier_solid, barrier_outside_corner_R],
               [barrier_solid, barrier_inside_corner_L, barrier_inside_corner_R, barrier_solid],
               [barrier_solid, empty, empty, barrier_solid]]

def reset_space_invaders(level):
    for row in range(0, NUMBER_OF_ROWS):
        for col in range(0, NUMBER_OF_COLS):
            itype = INVADER_TYPE_ROUND

            if row == 0:
                itype = INVADER_TYPE_TRIANGLE

            elif row == 1 or row == 2:
                itype = INVADER_TYPE_SQUARE

            invader = Invader(itype)
            invaders[row].append(invader)

            invader = invaders[row][col]
            rect = invader.get_rect()
            x = (col * 32) - (rect.width / 2) + XOFFSET
            y = (row * 32) + (YOFFSET + (level * 16))
            invader.move (x, y)
            invader.postion_in_array = [row, col]
    reset_alive()

def reset_alive():
    for col in range(0, NUMBER_OF_COLS):
        for row in range(0, NUMBER_OF_ROWS):
            alive = True
            dead_or_alive[col].append(alive)

def reset_barreir():
    barrier_full = []
    for barrier_num in range(0, 4):
        barrier_full.append([])
        for row in range(0, len(barrier_pos)):
            barrier_full[barrier_num].append([])
            for col in range(0, len(barrier_pos[row])):
                barrier_type = barrier_pos[row][col]
                if not barrier_type == empty:
                    barrier = Barrier(barrier_type)
                    barrier_full[barrier_num][row].append(barrier)
                    rect = barrier.get_rect()
                else:
                    barrier = Barrier_empty()
                    barrier_full[barrier_num][row].append(barrier)
                    rect = barrier.get_rect()

                x = (col * 8) - (rect.width / 2) + 50 +(100 * barrier_num)
                y = (row * 8) + (380)
                barrier.move (x, y)


class Gameobject:
    def __init__(self):
        self.imageframes = []
        self.frame = 0
        self.x = 0
        self.y = 0

    def animate(self):
        self.frame += 1
        if self.frame >= len(self.imageframes):
            self.frame = 0

    def draw(self, screen):
        screen.blit(self.imageframes[self.frame], self.get_rect())

    def move(self, x, y):
        self.x = x
        self.y = y

    def get_rect(self):
        image = self.imageframes[self.frame]
        rect = image.get_rect()
        rect.x = self.x
        rect.y = self.y

        return rect

    def checkcollision(self, x, y):
        rect = self.get_rect()
        return (x > rect.x and x < rect.x + rect.width
            and y > rect.y and y < rect.y + rect.height)



class Invader(Gameobject):
    def __init__(self, itype):
        Gameobject.__init__(self)
        self.itype = itype
        self.bullet_fired = False
        self.postion_in_array = []
        self.alive = True


        if itype == INVADER_TYPE_TRIANGLE:
            self.imageframes.append(pygame.image.load("Spaceinvaders triangle A.png"))
            self.imageframes.append(pygame.image.load("Spaceinvaders triangle B.png"))
        
        elif itype == INVADER_TYPE_SQUARE:
            self.imageframes.append(pygame.image.load("Spaceinvaders  square A.png"))
            self.imageframes.append(pygame.image.load("Spaceinvaders  square B.png"))

        elif itype == INVADER_TYPE_ROUND:
            self.imageframes.append(pygame.image.load("Spaceinvaders round A.png"))
            self.imageframes.append(pygame.image.load("Spaceinvaders round B.png"))

class Ship(Gameobject):
    def __init__(self):
        Gameobject.__init__(self)

        ship_png = pygame.image.load("ship.png")


        self.imageframes.append(ship_png)
        self.imageframes.append(pygame.image.load("ship_1.png"))
        self.imageframes.append(pygame.image.load("ship_2.png"))
        self.y = 420

        self.dead = False

        self.ship_fired = False

    def shoot(self):
        self.ship_fired = True

    def animate(self):
        self.frame += 1
        if self.frame >= len(self.imageframes):
            self.frame = 1


class Bullet(Gameobject):
    def __init__(self):
        Gameobject.__init__(self)

        self.imageframes.append(pygame.image.load("invibullet.png"))
        self.imageframes.append(pygame.image.load("bullet.png"))

    def bullet_destroyed(self):
        ship.ship_fired = False

class Explosion(Gameobject):
    def __init__(self):
        Gameobject.__init__(self)

        self.imageframes.append(pygame.image.load("explosion.png"))

class Invaderbullet(Invader):
    def __init__(self):
        Gameobject.__init__(self)

        self.bullet_fired = False
        self.imageframes.append(pygame.image.load("invader_bullet_invi.png"))
        self.imageframes.append(pygame.image.load("invader_bullet_a.png"))
        self.imageframes.append(pygame.image.load("invader_bullet_b.png"))

    def animate(self):
        self.frame += 1
        if self.frame >= len(self.imageframes):
            self.frame = 1

    def bulletshot(self):
        self.move(Invader.x, Invader.y)

class Barrier(Gameobject):
    def __init__(self, barrier_type):
        Gameobject.__init__(self)

        self.health = 5

        if barrier_type == barrier_inside_corner_L:
            self.imageframes.append(pygame.image.load("barrier_inside_L_corner_1.png"))
            self.imageframes.append(pygame.image.load("barrier_inside_L_corner_2.png"))
            self.imageframes.append(pygame.image.load("barrier_inside_L_corner_3.png"))
            self.imageframes.append(pygame.image.load("barrier_inside_L_corner_4.png"))
            self.imageframes.append(pygame.image.load("barrier_inside_L_corner_5.png"))

        elif barrier_type == barrier_inside_corner_R:
            self.imageframes.append(pygame.image.load("barrier_inside_R_corner_1.png"))
            self.imageframes.append(pygame.image.load("barrier_inside_R_corner_2.png"))
            self.imageframes.append(pygame.image.load("barrier_inside_R_corner_3.png"))
            self.imageframes.append(pygame.image.load("barrier_inside_R_corner_4.png"))
            self.imageframes.append(pygame.image.load("barrier_inside_R_corner_5.png"))

        elif barrier_type == barrier_outside_corner_L:
            self.imageframes.append(pygame.image.load("barrier_outside_L_corner_1.png"))
            self.imageframes.append(pygame.image.load("barrier_outside_L_corner_2.png"))
            self.imageframes.append(pygame.image.load("barrier_outside_L_corner_3.png"))
            self.imageframes.append(pygame.image.load("barrier_outside_L_corner_4.png"))
            self.imageframes.append(pygame.image.load("barrier_outside_L_corner_5.png"))

        elif barrier_type == barrier_outside_corner_R:
            self.imageframes.append(pygame.image.load("barrier_outside_R_corner_1.png"))
            self.imageframes.append(pygame.image.load("barrier_outside_R_corner_2.png"))
            self.imageframes.append(pygame.image.load("barrier_outside_R_corner_3.png"))
            self.imageframes.append(pygame.image.load("barrier_outside_R_corner_4.png"))
            self.imageframes.append(pygame.image.load("barrier_outside_R_corner_5.png"))

        elif barrier_type == barrier_solid:
            self.imageframes.append(pygame.image.load("barrier_block_1.png"))
            self.imageframes.append(pygame.image.load("barrier_block_2.png"))
            self.imageframes.append(pygame.image.load("barrier_block_3.png"))
            self.imageframes.append(pygame.image.load("barrier_block_4.png"))
            self.imageframes.append(pygame.image.load("barrier_block_5.png"))

class Barrier_empty(Gameobject):
    def __init__(self):
        Gameobject.__init__(self)
        self.imageframes.append(pygame.image.load("barrier_black.png"))
        self.health = 5
    def checkcollision(self, x, y):
        return False

if __name__ == "__main__":
    invaders = []

    pygame.mixer.init(frequency=22050, size=-16, channels=2, buffer=512)
    pygame.init()
    clock = pygame.time.Clock()
    screen = pygame.display.set_mode([WIDTH, HEIGHT])
    screen.fill(BLACK)
    font = pygame.font.SysFont("monospace", 15)


    fps = DEFAUTLT_FPS


    currentrow = NUMBER_OF_ROWS - 1
    movewait = 0
    direction_of_invader = 8
    direction_of_ship = 2
    direction_of_bullet = 6
    direction_of_bullet_invader = 5
    waitcycles = 55
    ship = Ship()
    ship_bullet = Bullet()
    explode = Explosion()
    show_explode = False
    invader_bullets = []
    for col in range(0, NUMBER_OF_COLS):
        invader_bullet = Invaderbullet()
        invader_bullets.append(invader_bullet)

    for row in range(0, NUMBER_OF_ROWS):
        invaders.append([])
    for col in range(0, NUMBER_OF_COLS ):
        dead_or_alive.append([])
    reset_space_invaders(0)

    for invader in invaders[NUMBER_OF_ROWS-1]:
        invader.bullet_clearpath = True

    ship_png = ship.imageframes[ship.frame]

    barrier_full = []
    for barrier_num in range(0, 4):
        barrier_full.append([])
        for row in range(0, len(barrier_pos)):
            barrier_full[barrier_num].append([])
            for col in range(0, len(barrier_pos[row])):
                barrier_type = barrier_pos[row][col]
                if not barrier_type == empty:
                    barrier = Barrier(barrier_type)
                    barrier_full[barrier_num][row].append(barrier)
                    rect = barrier.get_rect()
                else:
                    barrier = Barrier_empty()
                    barrier_full[barrier_num][row].append(barrier)
                    rect = barrier.get_rect()

                x = (col * 8) - (rect.width / 2) + 50 +(100 * barrier_num)
                y = (row * 8) + (380)
                barrier.move (x, y)



    sound_shoot = pygame.mixer.Sound("shoot.wav")
    sound_ship_death = pygame.mixer.Sound("explosion.wav")
    sound_invader_death = pygame.mixer.Sound("invaderkilled.wav")
    #name = raw_input("name:")
    game_finished = False
    ship_death_cycle = 0

###################################################################################################################

    while 1:

        pygame.event.pump()
        clock.tick(fps)

        screen.fill(BLACK)

        #keys pressed
        keys = pygame.key.get_pressed()

        if keys[pygame.K_ESCAPE] or keys[pygame.K_q]:
            pygame.quit()
            sys.exit(0)

        if not ship.dead:
            if keys[pygame.K_RIGHT]:
                if not ship.x + (ship.get_rect().width * 2) > WIDTH:
                    ship.move(ship.x + direction_of_ship, ship.y)

            elif keys[pygame.K_LEFT]:
                if not ship.x - (ship.get_rect().width) < 0:
                    ship.move(ship.x - direction_of_ship, ship.y)

            elif keys[pygame.K_SPACE]:
                if not ship.ship_fired:
                    ship.shoot()
                    sound_shoot.play()

            #if keys[pygame.K_r]:
            #    if lives == 0:
            #        reset_space_invaders(0)
            #        lives = max_lives
            #        score = 0
            #        reset_barreir()

        else:
            ship.animate()
            ship_death_cycle += 1
            if ship_death_cycle == 30:
                ship.frame = 0
                ship_death_cycle = 0
                ship.dead = False

        if lives <= 0:
            pygame.draw.line(screen, GREEN, [0, 440], [WIDTH, 440], 1)

            lives = 0
            label = font.render("NO MORE LIVES!!!", 1, RED)
            screen.blit(label, (WIDTH / 2 - (label.get_width() / 2), HEIGHT / 2))

            last_label_y = HEIGHT / 2
            label = font.render("Score - " + str(score), 1, YELLOW)
            screen.blit(label, (WIDTH / 2 - (label.get_width() / 2), last_label_y + label.get_height()))

            ship.draw(screen)
            pygame.display.flip()
            screen.fill(BLACK)
            #if not game_finished:
            #    highscores = file_reader("")

        else:
            if ship.ship_fired and ship_bullet.frame == 0:
                ship_bullet.animate()
                ship_bullet.move(ship.x + (ship.get_rect().width /2), ship.y)

            if ship.ship_fired:
                ship_bullet.move(ship_bullet.x, ship_bullet.y - direction_of_bullet)

            if ship_bullet.y <= 0:
                ship_bullet.frame = 0
                ship.ship_fired = False

            if ship_bullet.frame == 2:
                ship_bullet.frame = 0

            for invader_bullet in invader_bullets:
                if ship.checkcollision(invader_bullet.x, invader_bullet.y):
                    invader_bullet.move(0, 0)
                    lives -= 1
                    ship.animate()
                    ship.dead = True
                    sound_ship_death.play()

                if invader_bullet.y >= 510 :
                    invader_bullet.bullet_fired = False
                if invader_bullet.bullet_fired:
                    invader_bullet.move(invader_bullet.x, invader_bullet . y + direction_of_bullet_invader)
                    invader_bullet.animate()
                    invader_bullet.draw(screen)


            #UPDATE EVERYTHING
            movewait += 1

            if waitcycles == 0:
                waitcycles = 55

            if movewait % waitcycles == 0:

                random_invader_col = randint(0, 10)
                for row_in_dead_alive in range(NUMBER_OF_ROWS-1, 0, -1):
                    if dead_or_alive[random_invader_col][row_in_dead_alive]:
                        for row in invaders:
                            for invader in row:
                                if invader.postion_in_array == [row_in_dead_alive, random_invader_col]:
                                    break

                        invader_bullet = invader_bullets[random_invader_col]
                        if not invader_bullet.bullet_fired:
                            invader_bullet.bullet_fired = True
                            invader_bullet.animate()
                            invader_bullet.move(invader.x + invader.get_rect().width, invader.y)
                        break


                show_explode = False
                hitwall = False
                for row in range(0, len(invaders)):
                    for invader in invaders[row]:
                        if (direction_of_invader > 0 and invader.x + (invader.get_rect().width / 2) > WIDTH)\
                                or (direction_of_invader < 0 and invader.x < 0):
                            hitwall = True
                        if invader.y >= ship.y:
                            lives = 0

                if hitwall:
                    direction_of_invader  *= -1

                    for row in range(0, len(invaders)):
                        for invader in invaders[row]:
                            invader.y += 16
                            invader.move(invader.x + direction_of_invader, invader.y)
                            invader.animate()

                else:
                    for row in range(0, len(invaders)):
                        for invader in invaders[row]:
                            invader.move(invader.x + direction_of_invader, invader.y)
                            invader.animate()


            # DRAW EVERYTHING
            for row in invaders:
                for invader in row:
                    if invader.checkcollision(ship_bullet.x, ship_bullet.y):
                        if invader.itype == 1:
                            score += 20
                        elif invader.itype == 2:
                            score += 10
                        else:
                            score += 40
                        explode.move(invader.x, invader.y)
                        show_explode = True
                        row.remove(invader)
                        ship.ship_fired = False
                        ship_bullet.animate()
                        ship_bullet.move(0, 0)
                        waitcycles = waitcycles - 1
                        invader_num -= 1
                        posx = invader.postion_in_array[0]
                        posy = invader.postion_in_array[1]
                        dead_or_alive[posy][posx] = False

                        sound_invader_death.play()


                    invader.draw(screen)

            if show_explode:
                explode.draw(screen)

            if invader_num <= 0:
                invader_num = 55
                level += 1
                reset_space_invaders(level)

            for barrier_num in range(0, len(barrier_full)):
                for row in range(0, len(barrier_full[barrier_num])):
                    for col in range(0, len(barrier_full[barrier_num][row])):
                        try:
                            barrier = barrier_full[barrier_num][row][col]
                            if barrier.checkcollision(ship_bullet.x, ship_bullet.y):
                                barrier.animate()
                                barrier.health -= 1
                                print(barrier.health)
                                ship.ship_fired = False
                                ship_bullet.animate()
                                ship_bullet.move(0, 0)
                                if barrier.health <= 0:
                                    barrier_full[barrier_num][row].remove(barrier)
                                    break

                            for invader_bullet in invader_bullets:
                                if (barrier.checkcollision(invader_bullet.x, invader_bullet.y)):
                                    barrier.animate()
                                    barrier.health -= 1
                                    print(barrier.health)
                                    invader_bullet.bullet_fired = False
                                    invader_bullet.move(0, 0)
                                    if barrier.health <= 0:
                                        barrier_full[barrier_num][row].remove(barrier)
                                        break


                            barrier.draw(screen)
                        except:
                            None

            ship.draw(screen)

            ship_bullet.draw(screen)

            pygame.draw.line(screen, GREEN, [0, 440], [WIDTH, 440], 1)

            label = font.render("SCORE: " + str(int(score)), 1, WHITE)
            screen.blit(label, (8, 8))

            label = font.render(str(lives), 1, WHITE)
            screen.blit(label, (3, 453))

            for lives_dispaly in range(0, lives-1):
                screen.blit(ship_png, (15 + (lives_dispaly*30),450))

            pygame.display.flip()